
<%@page import="java.util.Comparator"%>
<%@page import="it.tref.liferay.mapit.constants.Constants"%>
<%@page import="it.tref.liferay.mapit.map.constants.PortletKeys"%>
<%@page import="javax.portlet.PortletRequest"%>
<%@page import="com.liferay.portlet.PortletURLFactoryUtil"%>
<%@page import="com.liferay.portal.kernel.language.LanguageUtil"%>
<%@page import="com.liferay.portal.security.permission.ResourceActionsUtil"%>
<%@page import="it.tref.liferay.mapit.util.ExpandoUtil"%>
<%@page import="com.liferay.portal.util.PortalUtil"%>
<%@page import="com.liferay.portal.service.PortletLocalServiceUtil"%>
<%@page import="java.util.Set"%>
<%@page import="java.util.HashSet"%>
<%@page import="com.liferay.portlet.expando.model.CustomAttributesDisplay"%>
<%@page import="it.tref.liferay.mapit.util.AssetUtil"%>
<%@page import="com.liferay.portal.kernel.util.ListUtil"%>
<%@page import="java.util.Collections"%>

<%@include file="/html/map_configuration/init.jsp" %>

<%
long companyId = company.getCompanyId();

String tab = ParamUtil.getString(request, "tab");

List<Long> classNameIds = ListUtil.toList(AssetUtil.getAvailableClassNameIds(companyId));

Collections.sort(classNameIds, new ResourceComparator(pageContext));

List<CustomAttributesDisplay> customAttributesDisplays = PortletLocalServiceUtil.getCustomAttributesDisplays();

Set<String> customAttributesEnabled = new HashSet<String>();
for(CustomAttributesDisplay customAttributesDisplay: customAttributesDisplays){
  customAttributesEnabled.add(customAttributesDisplay.getClassName());
}

PortletURL iteratorURL = renderResponse.createRenderURL();
iteratorURL.setParameter("tab", tab);

%>

<liferay-ui:search-container
	iteratorURL="<%= iteratorURL %>"
	total="<%= classNameIds.size() %>"
>
	<liferay-ui:search-container-results
		results="<%= ListUtil.subList(classNameIds,
		    searchContainer.getStart(), searchContainer.getEnd()) %>"
	/>

	<liferay-ui:search-container-row
		className="java.lang.Long"
		modelVar="classNameId"
	>
	
		<% 
		
		String className = PortalUtil.getClassName(classNameId);
		
		boolean existsLat = ExpandoUtil.exists(companyId, classNameId, Constants.EXPANDO_COLUMN_NAME_LAT)
		    	&& ExpandoUtil.exists(companyId, classNameId, Constants.EXPANDO_COLUMN_NAME_LAT_HIDDEN);
		boolean existsLon = ExpandoUtil.exists(companyId, classNameId, Constants.EXPANDO_COLUMN_NAME_LON)
		    	&& ExpandoUtil.exists(companyId, classNameId,  Constants.EXPANDO_COLUMN_NAME_LON_HIDDEN);
		
		boolean isTypeLat = true;
		boolean isIndexedLat = true;
		if (existsLat) {
			isTypeLat = ExpandoUtil.isType(companyId, classNameId, Constants.EXPANDO_COLUMN_NAME_LAT)
					&& ExpandoUtil.isType(companyId, classNameId, Constants.EXPANDO_COLUMN_NAME_LAT_HIDDEN);  
			isIndexedLat = ExpandoUtil.isIndexed(companyId, classNameId, Constants.EXPANDO_COLUMN_NAME_LAT_HIDDEN);  
		}
		
		boolean isTypeLon = true;
		boolean isIndexedLon = true;
		if (existsLon) {
			isTypeLon = ExpandoUtil.isType(companyId, classNameId, Constants.EXPANDO_COLUMN_NAME_LON)
					&& ExpandoUtil.isType(companyId, classNameId, Constants.EXPANDO_COLUMN_NAME_LON_HIDDEN);
			isIndexedLon = ExpandoUtil.isIndexed(companyId, classNameId, Constants.EXPANDO_COLUMN_NAME_LON_HIDDEN); 
		}
		
		boolean isValid = existsLat && existsLon && isTypeLat && isTypeLon && isIndexedLat && isIndexedLon;
		%>

		<liferay-ui:search-container-column-text
			buffer="buffer"
			name="resource"
		>

			<%
			buffer.append("<img align=\"left\" border=\"0\" src=\"");
			buffer.append(AssetUtil.getIconPath(liferayPortletRequest, className));
			buffer.append("\" style=\"margin-right: 5px;\">");
			buffer.append(ResourceActionsUtil.getModelResource(pageContext, className));
			%>

		</liferay-ui:search-container-column-text>
		<liferay-ui:search-container-column-text
			name="label-mapitconfiguration-indexable-column"
		> 			
			<%
			boolean hasIndexer = AssetUtil.hasIndexer(className);
			%>
		
			<liferay-ui:message key='<%= !hasIndexer ? "no" : "yes" %>' />
			<c:if test="<%= !hasIndexer %>">
				<liferay-ui:icon-help message="label-mapitconfiguration-indexable-not-present" />
			</c:if>
		</liferay-ui:search-container-column-text>
		
		<liferay-ui:search-container-column-text
			name="custom-fields"
		>  
				
			<liferay-ui:message key='<%=!existsLat && !existsLon ? "no" : "yes" %>' />
		
			<liferay-util:buffer var="helpMessage">
				<c:if test="<%= !isValid && (existsLat || existsLon)  %>">
					<ul>
						<c:if test="<%=!existsLat || !existsLon %>">
							<li>
								<%=LanguageUtil.get(pageContext,
								    "label-mapitconfiguration-custom-fields-could-not-be-found") %>
							</li>
						</c:if>
						<c:if test="<%=!isTypeLat || !isTypeLon %>">
							<li>
								<%=LanguageUtil.get(pageContext,
								    "label-mapitconfiguration-custom-fields-could-not-be-valid") %>
							</li>
						</c:if>
						<c:if test="<%=!isIndexedLat || !isIndexedLon %>">
							<li>
								<%=LanguageUtil.get(pageContext,
								    "label-mapitconfiguration-custom-fields-could-not-be-indexed") %>
							</li>
						</c:if>
					</ul>
				</c:if>
				<c:if test="<%=!customAttributesEnabled.contains(className)%>">
					<ul>
						<li>
							<%=LanguageUtil.get(pageContext,
							    "label-mapitconfiguration-custom-fields-could-not-be-editable") %>
						</li>
					</ul>
				</c:if>
			</liferay-util:buffer>
			<c:if test="<%= (!isValid && (existsLat || existsLon)) || !customAttributesEnabled.contains(className)%>">
				<liferay-ui:icon-help message="<%= helpMessage %>" />
			</c:if>
		</liferay-ui:search-container-column-text>
			
		<liferay-ui:search-container-column-text>
		
			<liferay-ui:icon-menu>
			
				<c:choose>
					<c:when test="<%=!existsLat && !existsLon%>">
						<portlet:actionURL name="editCustomFields" var="addURL">
							<portlet:param name="<%= Constants.CMD %>" value="<%= Constants.ADD %>" />
							<portlet:param name="redirect" value="<%= iteratorURL.toString() %>" />
							<portlet:param name="classNameId" value="<%= String.valueOf(classNameId) %>" />
						</portlet:actionURL>
				
						<liferay-ui:icon
							image="add"
							message="label-mapitconfiguration-add-custom-fields"
							url="<%= addURL %>"
						/>
					</c:when>
					<c:otherwise>
					
						<c:if test="<%= !isValid %>">
						
							<portlet:actionURL name="editCustomFields" var="updateURL">
								<portlet:param name="<%= Constants.CMD %>" value="<%= Constants.UPDATE %>" />
								<portlet:param name="redirect" value="<%= iteratorURL.toString() %>" />
								<portlet:param name="classNameId" value="<%= String.valueOf(classNameId) %>" />
							</portlet:actionURL>
					
							<liferay-ui:icon
								image="edit"
								message="label-mapitconfiguration-correct-custom-fields"
								url="<%= updateURL %>"
							/>
							
						</c:if>
						
						<%
						PortletURL editCustomFieldsURL = PortletURLFactoryUtil.create(request,
						    PortletKeys.EXPANDO, plid, PortletRequest.RENDER_PHASE);
						editCustomFieldsURL.setParameter("struts_action", "/expando/view_attributes");
						editCustomFieldsURL.setParameter("redirect", iteratorURL.toString());
						editCustomFieldsURL.setParameter("modelResource", className);
						%>
				
						<liferay-ui:icon
							image="edit"
							message="label-mapitconfiguration-edit-custom-fields"
							url="<%= editCustomFieldsURL.toString() %>" />
						
						<portlet:actionURL name="editCustomFields" var="deleteURL">
							<portlet:param name="<%= Constants.CMD %>" value="<%= Constants.DELETE %>" />
							<portlet:param name="redirect" value="<%= iteratorURL.toString() %>" />
							<portlet:param name="classNameId" value="<%= String.valueOf(classNameId) %>" />
						</portlet:actionURL>
				
						<liferay-ui:icon-delete 
							message="label-mapitconfiguration-delete-custom-fields"
							url="<%= deleteURL %>" />
					
					</c:otherwise>
				</c:choose>

			</liferay-ui:icon-menu>
		
		</liferay-ui:search-container-column-text>

	</liferay-ui:search-container-row>

	<liferay-ui:search-iterator />
</liferay-ui:search-container>

<%!
class ResourceComparator implements Comparator<Long> {
 
	private PageContext pageContext;

	public ResourceComparator(PageContext pageContext){
  		this.pageContext = pageContext;
	}

  	public int compare(Long classNameId1, Long classNameId2){
    	String name1 = ResourceActionsUtil.getModelResource(pageContext,
    	    PortalUtil.getClassName(classNameId1));
    	String name2 = ResourceActionsUtil.getModelResource(pageContext,
    	    PortalUtil.getClassName(classNameId2));
    	return name1.compareTo(name2);
  	}
}
%>
